<p>{{> theorie }}
    Der Inhalt einer angelegten Tabelle kann jederzeit ergänzt und verändert werden. Hierzu existieren
    drei Anweisungen, mit denen neue Daten eingefügt (<code>INSERT</code>), bestehende Daten verändert
    (<code>UPDATE</code>) und auch gelöscht (<code>DELETE</code>) werden können.
</p>
<h2>INSERT</h2>
<p>
    Mit der Anweisung <code>INSERT INTO</code> können Zeilen in die Tabelle eingefügt werden.
    Der Anweisung werden die Tabellennamen sowie die Spaltenbezeichnungen übergeben, die von der
    Operation betroffen sind. Entsprechend diesem Schema werden auch die Werte hinter
    <code>VALUES</code> eingegeben, um welche die Tabelle ergänzt werden soll. Das allgemeine
    SQL-Statement hierfür lautet:
</p>
<ul class="ovk-list">
    <li>
        <pre class="db-code"><code class="sql hljs">
INSERT INTO TabellenName (Spalte1, Spalte2, ...)
VALUES (Wert1, Wert2, ...);
</code></pre>
    </li>
</ul>
<p>
    Die Angabe der Spaltenbezeichnungen (Spalte1, Spalte2, ...) ist nicht zwingend erforderlich und wird
    eher dann gebraucht, wenn für das Anlegen eines neuen Eintrages die Wertangaben (Wert1, Wert2, ...)
    unvollständig sind. In dem Fall würde man die Spaltenbezeichnungen spezifizieren, für die die Werte
    mitgegeben werden.
</p>

<h2>UPDATE</h2>
<p>
    Die <code>UPDATE</code>-Anweisung dient dazu, die Daten in der Datenbank zu ändern.
    Mithilfe der <code>WHERE</code> - Klausel kann angegeben werden, welche Zeilen verändert werden
    sollen. Falls nur eine einzelne Zeile von Interesse ist, kann dies über eine ID (z.&nbsp;B. die S_Nr
    einer/s Schüler:in) geschehen. Die tatsächliche Änderung der jeweiligen Tabellenspalte wird mit
    <code>SET</code> angegeben. Der Befehl lautet:
</p>
<ul class="ovk-list">
    <li>
        <pre class="db-code"><code class="sql hljs">
UPDATE TabellenName
SET Spalte1 = Wert1, Spalte2 = Wert2, ...
WHERE Bedingung;
</code></pre>
    </li>
</ul>

<h2>DELETE</h2>
<p>
    Die Anweisung <code>DELETE</code> wird zum Löschen von Zeilen einer Tabelle genutzt. Dazu wird
    ebenfalls über WHERE angegeben, für welche Zeile(n) dies erfolgen soll. Die Notation dafür lautet:
</p>
<ul class="ovk-list">
    <li>
        <pre class="db-code"><code class="sql hljs">
DELETE FROM TabellenName
WHERE Bedingung;
</code></pre>
    </li>
</ul>
<div class="tom">
    <p>
        Allerdings birgt das <code>DELETE</code> bei unachtsamen Gebrauch einige Risiken und kann dazu
        führen, dass die Daten inkonsistent werden, indem bspw. ein Eintrag gelöscht wird, den ein
        anderer Eintrag noch referenziert. Um diese Situationen zu vermeiden, werden an die Datenbank
        zusätzliche Bedingungen zur Erhaltung der Vollständigkeit und Konsistenz gestellt, die sich
        unter dem Begriff <span class="bold">Referentielle Integrität</span> zusammenfassen lassen.
    </p>
    <p>
        Ein Beispiel, bei dem die Referentielle Integrität nicht berücksichtigt wird, ist im Folgenden
        abgebildet. Hier wurde der Eintrag (5, Fotografie) gelöscht, welcher jedoch noch referenziert
        wird. Das führt dazu, dass der Fremdschlüssel 5 im Eintrag (3, Carolin, 5) auf einen nicht
        existierenden Eintrag verweist:
    </p>
    <div class="container">
        <div class="row justify-content-around">
            <div class="col-3">
                <b>Vor dem <code>DELETE</code>-Befehl </b>
            </div>
            <div class="col-3">
                <b>Nach dem <code>DELETE</code>-Befehl </b>
            </div>
        </div>
        <div class="row">
            <div class="col-sm">
                <table class="table table-sm table-bordered" style="border-color: black;">
                    <thead style="background-color: #f0f2f5;;">
                        <tr>
                            <th>S_Nr</th>
                            <th>Name</th>
                            <th>GTA_Nr</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>1</td>
                            <td>Katrin</td>
                            <td>2</td>
                        </tr>
                        <tr>
                            <td>3</td>
                            <td>Carolin</td>
                            <td>5</td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <div class="col-sm">
                <table class="table table-sm table-bordered"
                    style="border-color: black; margin: 0 1em 0 -1em;">
                    <thead style="background-color: #f0f2f5;">
                        <tr>
                            <th>GTA_Nr</th>
                            <th>Beschreibung</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>2</td>
                            <td>Tastaturschreiben</td>
                        </tr>
                        <tr>
                            <td>5</td>
                            <td>Fotografie</td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <div class="col-sm">
                <table class="table table-sm table-bordered"
                    style="border-color: black; margin-left: 1em;">
                    <thead style="background-color: #f0f2f5;">
                        <tr>
                            <th>S_Nr</th>
                            <th>Name</th>
                            <th>GTA_Nr</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>1</td>
                            <td>Katrin</td>
                            <td>2</td>
                        </tr>
                        <tr>
                            <td>3</td>
                            <td>Carolin</td>
                            <td>5</td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <div class="col-sm">
                <table class="table table-sm table-bordered" style="border-color: black;">
                    <thead style="background-color: #f0f2f5;">
                        <tr>
                            <th>GTA_Nr</th>
                            <th>Beschreibung</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>2</td>
                            <td>Tastaturschreiben</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <p>
        Zur Erhaltung der Referentiellen Integrität beim Löschen gibt es die folgenden
        Möglichkeiten<br />
    <ul class="ovk-bullet-list">
        <li><span class="bold">Löschweitergabe (Kaskadierendes Löschen)</span>: Das Löschen eines
            Eintrages hat auch das Löschen aller Einträge zur Folge, die diesen referenzieren</li>
        <li><span class="bold">Änderungsweitergabe</span> (<code>SET NULL</code> oder
            <code>SET DEFAULT</code>): In den Zeilen, die mittels Fremdschlüsselattributes
            auf den zu löschenden Eintrag verweisen, wird als Attributwert des Fremdschlüssels
            <code>NULL</code> bzw. der Standardwert des Attributs eingetragen.
        </li>
        <li>
            <code>RESTRICT</code> oder <code>NO ACTION</code>: Die Löschung der Zeile wird nicht
            ausgeführt, wenn andere Datensätze noch auf diese verweisen.
        </li>
    </ul>
    </p>
</div>


<h2>Die Operatoren am Beispiel</h2>
<p>
    Zum besseren Verständnis sind nachfolgend einige Beispiele abgebildet, die illustrieren sollen, wie
    mit den eben vorgestellten Anweisungen gearbeitet werden kann.
</p>
<ul class="ovk-list">
    <li> Ein Schüler (S_Nr = 2) wählt ein bestimmtes GTA (GTA_Nr = 4), weswegen die GTA_Nr des Schülers
        geändert wird:
        <pre class="db-code">
<code class="sql hljs">
UPDATE Schueler
SET GTA_Nr = 4
WHERE S_Nr = 2;
</code>
</pre>
    </li>
    <li> Die Schule hat einen neuen Schüler bekommen, der allerdings noch kein GTA ausgewählt hat.
        Dieser wird mit folgenden Werten in der Datenbank eingefügt: <br>
        (S_Nr = 4, Nachname = Freud, Vorname = Philipp, Klassenstufe = 10)
        <pre class="db-code">
<code class="sql hljs">
INSERT INTO Schueler (S_Nr, Nachname, Vorname, Klassenstufe)
VALUES (4, 'Freud', 'Philipp', 10);
</code>
</pre>
    </li>
    <li> Ein Schüler (S_Nr = 4) macht seinen Abschluss und wird daher aus der Datenbank der Schule
        entfernt:
        <pre class="db-code">
<code class="sql hljs">
DELETE FROM Schueler
WHERE S_NR = 4;
</code>
</pre>
    </li>
</ul>
<div class="card ovk-story">
    <div class="card-header schon-gewusst-header">
        {{> info }}
        <div style="padding-top: 0.2em;">Schon gewusst?</div>
    </div>
    <div class="card-body schon-gewusst-body">
        <p>
            In der Praxis kann es auch vorkommen, dass beim <code>INSERT INTO</code>
            die ID (in diesem Fall die S_Nr) nicht explizit angegeben, sondern von der Datenbank
            automatisch vergeben wird, sobald man ein neues Objekt einfügt. In so einem Fall handelt es
            sich bei der Spalte meist um
            ein <a
                href="https://dev.mysql.com/doc/refman/8.0/en/example-auto-increment.html">automatisch
                inkrementierendes</a> (in SQL: <code>AUTO_INCREMENT</code>) Feld.
        </p>
        Im Fall des Schülers würde es also so aussehen:
        <p>
        <pre class="db-code">
<code class="sql hljs">
INSERT INTO Schueler (Nachname, Vorname, Klassenstufe, GTA_id)
VALUES ('Freud', 'Philipp', 10, 2);
</code>
</pre>

